distributive-0.5.1: Distributive functors -- Dual to Traversable

Copyright | (C) 2011-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Data.Distributive.Generic

Description

Synopsis

- class GDistributive g where
- genericDistribute :: (Functor f, Generic1 g, GDistributive (Rep1 g)) => f (g a) -> g (f a)

# Documentation

class GDistributive g where #

Minimal complete definition

gdistribute

Methods

gdistribute :: Functor f => f (g a) -> g (f a) #

Instances

GDistributive U1 # |
Methods gdistribute :: Functor f => f (U1 a) -> U1 (f a) #
GDistributive Par1 # |
Methods gdistribute :: Functor f => f (Par1 a) -> Par1 (f a) #
GDistributive f => GDistributive (Rec1 f) # |
Methods gdistribute :: Functor f => f (Rec1 f a) -> Rec1 f (f a) #
(GDistributive a, GDistributive b) => GDistributive ((:*:) a b) # |
Methods gdistribute :: Functor f => f ((a :*: b) a) -> (a :*: b) (f a) #
(Functor a, GDistributive a, GDistributive b) => GDistributive ((:.:) a b) # |
Methods gdistribute :: Functor f => f ((a :.: b) a) -> (a :.: b) (f a) #
GDistributive f => GDistributive (M1 i c f) # |
Methods gdistribute :: Functor f => f (M1 i c f a) -> M1 i c f (f a) #

genericDistribute :: (Functor f, Generic1 g, GDistributive (Rep1 g)) => f (g a) -> g (f a) #

`distribute` derived from a `Generic1` type

This can be used to easily produce a `Distributive` instance for a type with a `Generic1` instance,

    data V2 a = V2 a a deriving (Show, Functor, Generic1)
    instance Distributive V2' where distribute = genericDistribute